﻿using Prism.Mvvm;

namespace Borepin.Model
{
    public enum MachineStates
    {
        Free,
        InUse,
        ToCheck,
        Blocked,
        Disabled,
        Reserved
    }

    public class Machine : BindableBase
    {
        private string _ID;
        public string ID
        {
            get => _ID;
            set => SetProperty(ref _ID, value);
        }

        private MachineStates _State;
        public MachineStates State
        {
            get => _State;
            set => SetProperty(ref _State, value);
        }

        private string _Description;
        public string Description
        {
            get => _Description;
            set => SetProperty(ref _Description, value);
        }

        private User _User;
        public User User
        {
            get => _User;
            set => SetProperty(ref _User, value);
        }
    }

    public class User
    {
        public string ID { get; set; }

        public string Name { get; set; }

        public string OriginalWorkshop { get; set; }
    }
}
