﻿using Borepin.Model;
using System;
using System.Threading.Tasks;
using Xamarin.Essentials;

namespace Borepin.Service.Credentials
{
    public class CredentialService : ICredentialService
    {
        public async Task<string> GetPasswordAsync(Connection connection)
        {
            if (connection.AuthenticationTyp != AuthenticationTyp.PLAIN)
            {
                throw new ArgumentException("AuthenticationTyp is not PLAIN");
            }

            return await SecureStorage.GetAsync(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username));
        }

        public async Task<bool> AddCredentialsAsync(Connection connection, string password)
        {
            await SecureStorage.SetAsync(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username), password);

            return await Task.FromResult(true);
        }

        public async Task<bool> RemoveCredentialsAsync(Connection connection)
        {
            SecureStorage.Remove(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username));
            
            return await Task.FromResult(true);
        }
    }
}
